LibreOffice LibreOffice 25.8 SDK API Reference

Public Member Functions | List of all members
XBridgeSupplier2 Interface Referencepublished

defines the interface for creating bridges to other object models. More...

`import"XBridgeSupplier2.idl";`

Inheritance diagram for XBridgeSupplier2:

## Public Member Functions
any | createBridge ([in] any aModelDepObject, [in] sequence< byte > aProcessId, [in] short nSourceModelType, [in] short nDestModelType) raises ( com::sun::star::lang::IllegalArgumentException )
| creates a bridge to provide an object of one object model with another. More...
Public Member Functions inherited from XInterface
any | queryInterface ([in] type aType)
| queries for a new interface to an existing UNO object. More...
void | acquire ()
| increases the reference counter by one. More...
void | release ()
| decreases the reference counter by one. More...

## Detailed Description

defines the interface for creating bridges to other object models.

The created bridges are transparent to the user. That is, if one maps an interface into the target model, then the resulting target interface is a bridge implementation, that is not being noticed by an user. During a call on that interface, the bridge is invoked to convert the arguments and carry out a call according to the rules of the source model. Return values are automatically mapped to the types of the target model.

Simple types are mapped to simple target types. That is, there is no additional bridging code involved when those types are being used.

Sometimes a bridge cannot be created, depending on whether a program uses the XBridgeSupplier2 interface remotely. Assuming one wants to bridge an OLE Automation object to UNO by calling createBridge on a proxy, then the UNO remote bridge would not recognise that the Any argument contains an IDispatch interface. Therefore it cannot marshal it as COM requires it and the bridgeing would fail. To prevent this, implementations of this interface should be aware of this scenario and if necessary take the appropriate steps. The process ID argument to the createBridge function represents the calling process and may be used by the implementation to determine if it is being accessed remotely.

All objects, whether they are part of the UNO object model or not, are carried in an `any`. The representation of this object is heavily model-dependent and has to be specified in the following list:

UNO:

  The any carries normal UNO types, which can be any base type, struct, sequence, enum or interface.

OLE:

  The any carries an `unsigned long` (on 32-bit systems) or an `unsigned hyper` (on 64-bit systems), which is interpreted as a variant pointer. The any does not control the lifetime of the represented variant. That implies that the caller has the responsibility of freeing the OLE resources represented by the any value.

JAVA:
  not specified yet.

Any implementation can supply its own bridges to other object models by implementing this interface and returning the bridge when the method XBridgeSupplier2::createBridge() is called with itself as the first parameter.

See also
  com::sun::star::bridge::OleBridgeSupplier2

## Member Function Documentation

## ◆ createBridge()

any createBridge | ( | [in] any | aModelDepObject,
|  | [in] sequence< byte > | aProcessId,
|  | [in] short | nSourceModelType,
|  | [in] short | nDestModelType
| ) |  |
raises | ( | com::sun::star::lang::IllegalArgumentException
| ) |  |

creates a bridge to provide an object of one object model with another.

The documentation for this interface was generated from the following file:

- com/sun/star/bridge/XBridgeSupplier2.idl